import processing.core.*; 
import processing.xml.*; 

import java.awt.event.*; 
import java.util.ArrayList; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class imap_interface_v3 extends PApplet {

//-----------------------
// imap interface v3
//-----------------------
// A Project from Elli Scambor, Fr\u00e4nk Zimmer, Heimo Ranzenbacher
// Graz/Austria 2008
// copyright Scambor, Zimmer, Ranzenbacher





PFont font, font0, font1, font2, font3, font4, font5;


Button[] Geschlecht = new Button[3];
Button[] Alter = new Button[5];
Button[] Migration = new Button[4];
Button[] Bildung = new Button[4];
Button[] Einkommen = new Button[5];
Button[] Sprache = new Button[2];

int virtuell =0;
// F\u00fcr Filter
int geschlecht = 0;
int age = 0;
int minage = 0;
int maxage = 1000;
int migration = 0;
int minmigration = 0;
int maxmigration = 3;
int education = 0;
int mineducation = 0;
int maxeducation = 1000;
int income = 0;
float minincome = -1;
float maxincome = 1000;

int info = 0;
int sprache =0;

// F\u00fcr Eingabefeld
String typing = "";
Boolean edit = false;

//grav rect
float stiffness = 2.0f;
float damping = 0.3f;
float velocity = 0.1f;
float targetY;
float y;
//----------


int help;
//Fade
//int opacity = 0;
//int direction = 1;

Viewer viewer;


//---------------------------------------------------------------

public void setup() {
 size(1024, 768);
 font0 = loadFont("AlMateen-Bold-9.vlw");
 font1 = loadFont("Verdana-10.vlw");
 font2 = loadFont("Verdana-Bold-10.vlw");
 font3 = loadFont("Verdana-Bold-12.vlw");
 font4 = loadFont("Verdana-Bold-22.vlw");
 font5 = loadFont("Verdana-Bold-14.vlw");


  frame.addMouseWheelListener(new MouseWheelInput());
  
  // Definition der Buttons ----Inputs: x, y, size,
  Geschlecht [0] = new Button(314, 653, 15, 0, Geschlecht);
  Geschlecht [1] = new Button(314, 673, 15, 1, Geschlecht);
  Geschlecht [2] = new Button(314, 693, 15, 2, Geschlecht);
  Alter [0] = new Button(459, 653, 15, 0, Alter);
  Alter [1] = new Button(459, 673, 15, 1, Alter);
  Alter [2] = new Button(459, 693, 15, 2, Alter);
  Alter [3] = new Button(459, 713, 15, 3, Alter);
  Alter [4] = new Button(459, 733, 15, 4, Alter);
  Migration [0] = new Button(604, 653, 15, 0, Migration);
  Migration [1] = new Button(604, 673, 15, 1, Migration);
  Migration [2] = new Button(604, 693, 15, 2, Migration);
  Migration [3] = new Button(604, 713, 15, 3, Migration);
  Bildung [0] = new Button(749, 653, 15, 0, Bildung);
  Bildung [1] = new Button(749, 673, 15, 1, Bildung);
  Bildung [2] = new Button(749, 693, 15, 2, Bildung);
  Bildung [3] = new Button(749, 713, 15, 3, Bildung);
  Einkommen [0] = new Button(894, 653, 15, 0, Einkommen);
  Einkommen [1] = new Button(894, 673, 15, 1, Einkommen);
  Einkommen [2] = new Button(894, 693, 15, 2, Einkommen);
  Einkommen [3] = new Button(894, 713, 15, 3, Einkommen);
  Einkommen [4] = new Button(894, 733, 15, 4, Einkommen);
 //Sprache [0] = new Button(40, 670, 10, 0, Sprache);
 // Sprache [1] = new Button(40, 690, 10, 1, Sprache);   
  
  // Viewer mit Kartengr\u00f6sse initialisieren
  viewer = new Viewer(0,0,1024,768);
  viewer.filter(geschlecht,minage,maxage,minmigration,maxmigration,mineducation,maxeducation,minincome,maxincome);
}

//----------------------------------------------------------------

public void draw() {
 background(255);
 smooth();
 viewer.draw();
 viewer.drawPointInfo(10,10,sprache);


//-----------------------------------------------------------------------
// ROLLOVER-TEXTE
//-----------------------------------------------------------------------
 
 //MIGRATION - TEXT
 if (mouseX > 600 && mouseX < 730 && mouseY > 600 && mouseY < 800 ) {
 fill(0,102,153,180);
 rect(0,200, 1500, 250);
 fill(255);
 textFont(font4);
 if (sprache == 0)
 {
 text("MIGRATION", 40, 230);
 textFont(font5);
 text("Filtern Sie nach Migration.",40,260);
 text("Alle: Alle Staatsb\u00fcrgerInnen",40, 285);
 text("\u00d6sterreich: \u00d6sterreichische Staatsb\u00fcrgerInnen in der ersten und zweiten Generation.",40, 310);
 text("EU: EU-Staatsb\u00fcrgerInnen (ohne \u00d6sterreich) in der ersten und zweiten Generation.",40,335);
 text("Nicht-EU: Nicht-EU-Staatsb\u00fcrgerInnen in der ersten und zweiten Generation.",40,360); 
 } 
 else if ( sprache == 1 )                  // english
 {
text("MIGRATION", 40, 230);
 textFont(font5);
 text("Select citizens.",40,260);
 text("All: Select all citizens.",40,285);
 text("Austria: Austrian citizens; first and second generation",40, 310);
 text("EU: Citizens of the European Union member states (no A); first and second generation",40, 335);
 text("N-EU: Citizens of countries outside the European Union member states; first and second generation",40,360);
 }
 }
 
 //BILDUNG - TEXT
 if (mouseX > 745 && mouseX < 880 && mouseY > 600 && mouseY < 800 ) {
 fill(0,102,153,180);
 rect(0,200, 1500, 250);
 fill(255);
 textFont(font4);
  if (sprache == 0)
 {
 text("BILDUNG", 40, 230);
 textFont(font5);
 text("Filtern Sie nach Bildung.",40,260);
 text("Alle: Alle Bildungsgruppen",40, 285);
 text("Hoch: Fachhochschule, Kollege, Akademie, Universit\u00e4t",40, 310);
 text("Mittel:Lehrabschluss, Allgemeinbildung und Berufsbildung mit und ohne Matura",40,335);
 text("Niedrig: Volksschule, Hauptschule",40,360); 
 textFont(font2);
 text("Die Bildungskategorien wurden den ISCED-Levels (International Standard Classification of Education) angepasst.",40,385); 
 }  else if ( sprache == 1 )                  // english
 {
 text("Education", 40, 230);
 textFont(font5);
 text("Select levels of education.",40,260);
 text("All: Select all levels of education.",40, 285);
 text("High: Tertiary education first stage and second stage.",40, 310);
 text("Middle: Secondary education first stage, second stage and post secondary education.",40,335);
 text("Low: Primary education.",40,360); 
 textFont(font2);
 text("The levels of education were developed according to the International Standard Classification of Education (ISCED).",40,410);
 }
 }
 
 
//EINKOMMEN - TEXT
 if (mouseX > 890 && mouseX < 970 && mouseY > 600 && mouseY < 800 ) {
 fill(0,102,153,180);
 rect(0,200, 1500, 250);
 fill(255);
 textFont(font4);
   if (sprache == 0)
 {
 text("EINKOMMEN", 40, 230);
 textFont(font5);
 text("Filtern Sie nach Einkommen:",40,260);
 text("Alle: alle Einkommensgruppen.",40, 285);
 text("Hoch: \u00dcber der dreifachen Armutsgef\u00e4hrdungsschwelle",40, 310);
 text("Mittel: Doppelte bis dreifache Armutsgef\u00e4hrdungsschwelle",40,335);
 text("Niedrig: An der Armutsgef\u00e4hrdungsschwelle bis doppelte Armutsgef\u00e4hrdungsschwelle",40,360); 
 text("Sehr niedrig: Unter der Armutsgef\u00e4hrdungsschwelle",40,385); 
 textFont(font2);
 text("Das verf\u00fcgbare monatliche Netto-Haushalteinkommen (inkl. 13. + 14. Monatsgehalt, Familienbeihilfe, Kinderbetreuungsgeld und andere Transferzahlungen)",40,410);
 text("wird mit der Armutsgef\u00e4hrungsschwelle in Bezug gesetzt. Diese betr\u00e4gt im Jahr 2008 f\u00fcr einen Einpersonen-Haushalt 926 Euro (wertangepasst) ", 40,430); 
 } else if ( sprache == 1 )                  // english
 { 
 textFont(font4);
 text("INCOME", 40, 230);
 textFont(font5);
 text("Select levels of income.",40,260);
 text("All: select all levels of income",40, 285);
 text("High: More than three times At-Risk-of-Poverty-Threshold (AROPT)",40, 310);
 text("Middle: Double to three times AROPT",40,335);
 text("Low: From AROPT to double AROPT",40,360); 
 text("Very low income: Under AROPT",40,385); 
 textFont(font2);
 text("The disposable net household income (including transfer payments, e.g. family allowance, childcare benefit, and similar) is related to AROPT",40,410);
 text("The AROPT is approx. \u20ac 926,-- for a single person household in 2008 (basis: inflation-adjusted AROPT of 2006 ", 40,430);  
 }
 }
 
 // INFO-TEXT
 if (info==1 ) {   
 fill(0,102,153,200);
 rect(0,180, 1500, 500);
 fill(255);
 textFont(font4);
   if (sprache == 0)
 {
 text("intersectional map/graz08", 40, 210);
 textFont(font5);
 text("Geschlecht, Ethnie, Milieu und Alter als Achsen der Ungleichheit einer Stadt ",40,230);
 text("Elli Scambor, Fr\u00e4nk Zimmer und Heimo Ranzenbacher",40, 250);
 textFont(font3);
 text("Die intersectional map /graz08 bewegt sich an der Schnittstelle von Wissenschaft und Kunst. ",40, 280);
 text("Die Kategorien Geschlecht, Migration, Milieu und Alter stehen im Fokus einer soziologischen Studie, die typische Alltagswege",40,305);
 text("und Orte von 1650 StadtbewohnerInnen erfasst. Daraus wurde ein virtueller Stadtplan entwickelt. Das Projekt konzentriert",40,320); 
 text("sich auf die Frage, wie eine Stadt im Handeln ihrer BewohnerInnen entsteht. Die Diversit\u00e4t der Lebensumst\u00e4nde unterschiedlicher",40,335); 
 text("Bev\u00f6lkerungsgruppen bildet dabei ein wesentliches Prinzip der Strukturierung.",40,350);
 text("Vier mobile Medieninstallationen machen die Studie im \u00f6ffentlichen Raum sichtbar und h\u00f6rbar.", 40, 370);
 text("An Schaufenstern und Terminals sind Kameras angebracht, die Schnappsch\u00fcsse der BenutzerInnen der Installationen machen.", 40, 385); 
 text("Die 4 Medieninstallationen sind untereinander vernetzt. Am oberen Rand der Bildschirme zeigt eine Bildleiste, wo und von ",40, 400); 
 text("welchen Personen die Installationen benutzt werden. Der Gebrauch der Installationen erzeugt einen neuen Ort im virtuellen Stadtplan. ",40,415);
 text("In Analogie zum Gebrauch des realen st\u00e4dtischen Gef\u00fcges wird auch bei der Installation die Alltagswertigkeit eines Ortes durch ", 40,430); 
 text("den Gebrauch des Ortes bestimmt.", 40,445);
 text("Durchf\u00fchrende Organisation: Forschung M\u00e4nnerberatung Graz in Kooperation mit GenderWerkst\u00e4tte, Liquid Music und mur.at.", 40,465);
 text("Gef\u00f6rdert durch: Kultur Steiermark |BMUKK |BMWF |Graz Stadt Wissenschaft.", 40,480);
 text("Standorte der ersten 4 Installationen (November 2008 - Dezember 2008): Grazer Stadtwerke, Andreas-Hofer-Platz 15,", 40, 500);
 text("Shopping Nord, Wiener Stra\u00dfe 351 |Stadtbibliothek Graz West, Eggenberger Allee 13a |tag-werk Caritas, Mariahilferstra\u00dfe 13.", 40,515); 
 text("http://intersectional-map.mur.at", 40,535); 
 }   else if ( sprache == 1 )   
 {
 text("intersectional map/graz08", 40, 210);
 textFont(font5);
 text("Gender, ethnicity, class and age as axes of inequality in a city",40,230);
 text("Elli Scambor, Fr\u00e4nk Zimmer and Heimo Ranzenbacher",40, 250);
 textFont(font3);
 text("Intersectional map /graz08 is an interdisciplinary science & art project.",40, 280);
 text("It focuses on gender, ethnicity, age and class as axes of inequality in the structure of urban spaces. ",40,305);
 text("A questionnaire survey, carried out in the city of Graz, concentrated on daily ways and locations of 1650 inhabitants.",40,320); 
 text("The relationships among multiple dimensions itself is an important category of analysis.",40,335); 
 text("The creation of urban spaces as intersectional spaces will be illustrated on the basis of a scientific motion study.",40,350); 
 text("Four mobile media installations in public spaces act as instruments to navigate through the intersectional map.",40,370);
 text("At shop windows cameras are affixed, they do snapshots of the users of the installations.The four media installations", 40,385); 
 text("are networked with each other. On the upper part of the screen a picture bar displays people using the installations. ", 40,400); 
 text("The use of the installations produces a new location in the virtual map. In analogy to the use of the real urban",40,415); 
 text("areas by citizens, the everyday value of a location in the virtual map is determined by the intensity ot its use.",40,430);
 text("Executive Organisation: Research Institute at Men's Counseling Center Graz, cooperation with GenderWerkst\u00e4tte, Liquid Music, mur.at.", 40,450); 
 text("Supported by: Kultur Steiermark |BMUKK |BMWF |Graz Stadt Wissenschaft.", 40,465); 
 text("Locations of the first series of installations (November 2008 - Dezember 2008): Grazer Stadtwerke, Andreas-Hofer-Platz 15,", 40,485);
 text("Shopping Nord, Wiener Stra\u00dfe 351 | Stadtbibliothek Graz West, Eggenberger Allee 13a, tag-werk Caritas, Mariahilferstra\u00dfe 13.", 40,500);
 text("http://intersectional-map.mur.at", 40,520); 
 
  }
}
    
  // IHELP-TEXT
 if (  info== 2) {   
 fill(0,0,0,150);
 rect(0,180, 1500, 500);
 fill(255);
textFont(font4); 
 if (sprache == 0)
 {
 text("help", 20, 210);

 textFont(font3);
 text("Marker sind Personen. Die Symbole sind unterschiedlichen Personengruppen zugewiesen: ",40,250);
//Legende
//Frauen
strokeWeight(1);
stroke(180,216,0,255);
fill(180,216,0,120);
rect(40,260,10,10);
text("Frauen(A)",70,270);
text("Frauen(EU)",70,295);
text("Frauen(N-EU)",70,320);
triangle(40,295,45,280,50,295);
quad(40, 318, 45,326,50,318,45,310);

//M\u00e4nner
stroke(0,178,235,255); 
fill(0,178,235,120);
rect(170,260,10,10);
text("M\u00e4nner(A)", 200,270);
text("M\u00e4nner(EU)", 200, 295);
text("M\u00e4nner(N-EU)", 200, 320);
triangle(170,295,175,280,180,295);
quad(170, 318, 175,326,180,318,175,310);

fill(255);
 text("Die Bewegung der Marker folgt den allt\u00e4glichen Wegen der befragten Personen. Die Marker vergr\u00f6\u00dfen sich an Orten,",40,350);
 text("die von den befragten Personen allt\u00e4glich aufgesucht werden; = Pulsieren am Ort.",40,365);
 text("Die Personenfrequenz an Orten wird durch die Gr\u00f6\u00dfe der Punkte dargestellt. Das Farbkontinuum kennzeichnet",40,400);
 text("die Heterogenit\u00e4t der Orte. Dunkle Farben symbolisieren hohe Werte und damit eine hohe Diversit\u00e4t der Personen am Ort.",40,415);
 text("Niedrige Werte verweisen auf geringe Unterschiede zwischen Personen. Die Auswahl eines Ortes \u00f6ffnet die dazugeh\u00f6rende ",40,430);
 text("Legende am linken Bildrand. In der Legende sind folgende Werte angegeben:", 40, 445);
 text("Heterogenit\u00e4tswert von 0 - 100, Personenfrequenz in absoluten Zahlen" , 40, 460);
 text("Prozentuale Angaben zu Geschlecht, Migration, Alter, Bildung und Einkommen.",40,475);
 text("Sobald ein Ort ausgew\u00e4hlt wird, bewegen sich Marker darauf zu. Es handelt sich dabei um Personen, die diesen Ort allt\u00e4glich aufsuchen.", 40,490); 
  text("Mithilfe der Filterfunktion kann die allt\u00e4gliche Nutzung der Stadt durch ausgew\u00e4hlte Personengruppen visualisiert werden.",40,525); 
 text("Mithilfe der 4 Pfeiltasten kann die Karte bewegt werden und ein Ort markiert werden, um mehr \u00fcber ihn zu erfahren.",40,560); 
 text("Mithilfe der Lupe kann die Karte gezoomt werden.",40,575);
 fill(177,0,93);
  textFont(font5);
 text("Symbole",40,230);
 text("Orte",40,385);
 text("Filter",40,510); 
  text("Navigation",40,545); 
 
 } else if ( sprache == 1 )   
 
{ 
 text("help", 20, 210);
textFont(font3);
 text("Marker are people. Every single marker is a person. The symbols are assigned to different population groups:",40,250);
//Women
strokeWeight(1);
stroke(180,216,0,255);
fill(180,216,0,120);
rect(40,260,10,10);
text("Women(A)",70,270);
text("Women(EU)",70,295);
text("Women(N-EU)",70,320);
triangle(40,295,45,280,50,295);
quad(40, 318, 45,326,50,318,45,310);
//Men
stroke(0,178,235,255); 
fill(0,178,235,120);
rect(170,260,10,10);
text("Men(A)", 200,270);
text("Men(EU)", 200, 295);
text("Men(N-EU)", 200, 320);
triangle(170,295,175,280,180,295);
quad(170, 318, 175,326,180,318,175,310);

fill(255);
 text("The movement of the marker follows daily ways of the survey respondents. The markers enlarge at locations",40,350);
 text("which were frequented by survey respondents; = pulsation.",40,365);
 text("Number of people is size of the spots. The colour continuum characterizes heterogeneity of locations.",40,400);
 text("Dark colours symbolize high values, which means high diversity of people in selected locations.",40,415);
 text("Low values refer to low diversity of people at selected locations. ",40,430);
 text("Indicated value for heterogeneity on a continuum from 0 - 100", 40, 445);
 text("Number of people at location." , 40, 460);
 text("Percentage for gender, age, migration, education and income.",40,475);
 text("When a location is selected, marker/people who frequented the location move to this place.", 40,490); 
  text("Daily ways and locations of the survey respondents can be visualized through filter button.",40,525); 
 text("By dint of 4 arrow keys, tha map can be moved and locations can be marked, if further information is expected.",40,560); 
 text("Zoom into the map by zoom lens.",40,575);
 fill(177,0,93);
  textFont(font5);
 text("Symbols",40,230);
 text("Locations",40,385);
 text("Filter",40,510); 
  text("Navigation",40,545); 

}
}
  

  
// --------Rahmen f\u00fcr Buttons-Auswahl----------------
  noFill();
//stroke(206,206,206);
//fill(0,102,153);
  stroke(0,102,153);
  strokeWeight(6);
  strokeJoin(ROUND);
  fill(255,255,255);
  rect (310, 630, 125, 150); // Geschlecht
  rect (455, 630, 125, 150); // Alter
  rect (600, 630, 125, 150); // Migration
  rect (745, 630, 125, 150); // Bildung
  rect (890, 630, 125, 150); // Einkommen
  
  strokeWeight(20);
  rect (897, 625, 111, 10); // Einkommen +
  rect (752, 625, 111, 10); // Bildung +
  rect (607, 625, 111, 10); // Migration +
  rect (462, 625, 111, 10); // Alter +
  rect (317, 625, 111, 10); // Geschlecht +
  
   strokeWeight(6);
 
  //--------Titel-imap---------------------------------------
   fill(177,0,93);
  textFont(font5);
  text("intersectional map /graz",800, 30);
fill(0,102,153);
    textFont(font2);
   text("press: i=info  h=help  l=language", 800,50);
   text("press ESC to quit the applet", 800,70);
   
  

  //--------Buttongruppe-Texte-------------------------------
   fill(255,255,255);
  textFont(font2);
  if (sprache == 0)  {
  text("GESCHLECHT", 325, 635);
  text("ALTER", 470, 635);
  text("MIGRATION", 615, 635);
  text("BILDUNG", 760, 635);
  text("EINKOMMEN", 905, 635);
 // text("INFOS - DETAILS", 1160, 613);
 }  else if ( sprache == 1 )  {
  text("SEX", 325, 632);
  text("AGE", 470, 635);
  text("MIGRATION", 615, 635);
  text("EDUCATION", 760, 635);
  text("INCOME", 905, 635);
 }

 
  //--------Button aktiv/deaktiv plus Texte-------------------------------
  noFill();
  fill(77,77,77);
  textFont(font2);
  if (sprache == 0)  {
     text("Alle", 325, 664);
     text("Frauen", 325, 684);
       text("M\u00e4nner", 325, 704);
        text("Alle", 470, 667);
        text("10-19 Jahre", 470, 687);
         text("20-39 Jahre", 470, 707);
         text("40-59 Jahre", 470, 727);
           text("> 60 Jahre", 470, 747);
            text("Alle", 615, 667);
              text("\u00d6sterreich", 615, 687);
              text("EU", 615, 707);
              text("Nicht-EU", 615, 727);
                text("Alle", 760, 667);
                text("Hoch", 760, 687);
                text("Mittel", 760, 707);
                text("Niedrig", 760, 727);
                text("Alle", 905, 667);  
                text("Hoch", 905, 687);
                text("Mittel", 905, 707);
                  text("Niedrig", 905, 727);
                  text("Sehr niedrig", 905, 747);
                    }   
                    else if ( sprache == 1 )   {
                    text("all", 325, 667);
                    text("women", 325, 687);
                    text("men", 325, 707);
                    text("all", 470, 667);
                    text("10-19 years", 470, 687);
                    text("20-39 years", 470, 707);
                    text("40-59 years", 470, 727);
                    text("> 60 years", 470, 747);
                    text("all", 615, 667);
                    text("Austria", 615, 687);
                    text("EU", 615, 707);
                    text("Non-EU", 615, 727);
                    text("all", 760, 667);
                    text("high", 760, 687);
                    text("middle", 760, 707);
                    text("low", 760, 727);
                    text("all", 905, 667);  
                    text("high", 905, 687);
                    text("middle", 905, 707);
                    text("low", 905, 727);
                    text("very low", 905, 747);                
   }
   

  //--------Buttons Geschlecht
  Geschlecht[0].update();
  Geschlecht[0].display();
 
  Geschlecht[1].update();
  Geschlecht[1].display();
  
  Geschlecht[2].update();
  Geschlecht[2].display();


  //--------Buttons Alter
  Alter[0].update();
  Alter[0].display();
 
  Alter[1].update();
  Alter[1].display();
 
  Alter[2].update();
  Alter[2].display();
 
  Alter[3].update();
  Alter[3].display();
  
  Alter[4].update();
  Alter[4].display();


  //--------Buttons Migration
  Migration[0].update();
  Migration[0].display();
 
  Migration[1].update();
  Migration[1].display();

  Migration[2].update();
  Migration[2].display();

  Migration[3].update();
  Migration[3].display();


  //--------Buttons Bildung
  Bildung[0].update();
  Bildung[0].display();

  Bildung[1].update();
  Bildung[1].display();

  Bildung[2].update();
  Bildung[2].display();

  Bildung[3].update();
  Bildung[3].display();


  //--------Buttons Einkommen

  Einkommen[0].update();
  Einkommen[0].display();

  Einkommen[1].update();
  Einkommen[1].display();

  Einkommen[2].update();
  Einkommen[2].display();
  
  Einkommen[3].update();
  Einkommen[3].display();

  Einkommen[4].update();
  Einkommen[4].display();

 
  
  /*
  //--------Buttons Sprache   
 Sprache[0].update();
 Sprache[0].display();
text("deutsch",40,660);
 Sprache[1].update();
 Sprache[1].display();
text("english", 40,680);
*/

}

//-----------------------------------------------------------------
public void mousePressed() {

  // println("mousePressed()");
  if (Geschlecht[0].press())
  {
    println("0");
    geschlecht = 0;
  }
  if (Geschlecht[1].press())
  {
    println("2");
    geschlecht = 2;
  }
  if (Geschlecht[2].press())
  {
    println("1");
    geschlecht = 1;
  }

  if (Alter[0].press())
  {
    minage=0;
    maxage=1000;
  }
  if (Alter[1].press())
  {
    minage=0;
    maxage=19;
  }
  if (Alter[2].press())
  {
    minage=20;
    maxage=39;
  }
  if (Alter[3].press())
  {
    minage=40;
    maxage=59;
  }
  if (Alter[4].press())
  {
    minage=60;
    maxage=1000;
  }
  
  if (Migration[0].press())
  {
    minmigration = 0;
    maxmigration = 3;
  }
  if (Migration[1].press())
  {
    minmigration = 0;
    maxmigration = 0;
  }
  if (Migration[2].press())
  {
    minmigration = 1;
    maxmigration = 1;
  }
  if (Migration[3].press())
  {
    minmigration = 2;
    maxmigration = 2;
  }
  if (Bildung [0].press())
  {
    mineducation=0;
    maxeducation=1000;
  }
  if (Bildung [1].press())
  {
    mineducation=5;
    maxeducation=7;
  }
  if (Bildung [2].press())
  {
    mineducation=3;
    maxeducation=4;
  }
  if (Bildung [3].press())
  {
    mineducation=1;
    maxeducation=2;
  }
  if (Einkommen[0].press())
  {
    minincome=-1;
    maxincome=1000;
  }
  if (Einkommen[1].press())
  {
    minincome=3;
    maxincome=100;
  }
  if (Einkommen[2].press())
  {
    minincome=2;
    maxincome=3;
  }
  if (Einkommen[3].press())
  {
    minincome=1;
    maxincome=2;
  }
  if (Einkommen[4].press())
  {
    minincome=0;
    maxincome=1;
  }
  /*
    if (Sprache[0].press())
  {

  }
   if (Sprache[1].press())
  {
   
  }
*/
  
  viewer.filter(geschlecht,minage,maxage,minmigration,maxmigration,mineducation,maxeducation,minincome,maxincome);
  
  // println("mousePressed: " + mouseButton + " x: " + mouseX + " y: " + mouseY);
  viewer.mousePressed();

}

public void mouseDragged() {
  viewer.mouseDragged();
}

public void mouseReleased() {
  viewer.mouseReleased();
}

class MouseWheelInput implements MouseWheelListener {
  public void mouseWheelMoved(MouseWheelEvent e) {
    int step=e.getWheelRotation();
    if (step == -1) viewer.zoomin();
    if (step == +1) viewer.zoomout();
  }
}


public void keyPressed()
{
  if (edit == true)
  {
    if ((key == DELETE) || (key == RETURN) || (key == ENTER) )
    {
      edit = false;
      viewer.renamePoint(typing);
    } else if ((key == BACKSPACE) && (typing.length() > 0))
    {
      typing = typing.substring(0, typing.length() -1 );
    }
    else
    {
      if (key == CODED)
      {
      }
      else
      {
        typing = typing + key;
      }
    }
  }
  
  else
  {
    //-----------------------------------------
    // Buttons Kategorien lesen
    //-----------------------------------------
    
    if (key == '1' )  {

      geschlecht--;
      if (geschlecht < 0) geschlecht = 2;
      if (geschlecht == 1)
      {
        Geschlecht[2].over = true;
        Geschlecht[2].press();
      }
      else if (geschlecht == 2)
      {
        Geschlecht[1].over = true;
        Geschlecht[1].press();
      }
      else
      {
        Geschlecht[geschlecht].over = true;
        Geschlecht[geschlecht].press();
      }
viewer.filter(geschlecht,minage,maxage,minmigration,maxmigration,mineducation,maxeducation,minincome,maxincome);
    }

    if (key == '2' )
    {
      age++;
      if (age > 4) age = 0;

      Alter[age].over = true;
      Alter[age].press();
      
      if (age == 0)
      {
        minage=0;
        maxage=1000;
      }
      if (age == 1)
      {
        minage=0;
        maxage=19;
      }
      if (age == 2)
      {
        minage=20;
        maxage=39;
      }
      if (age == 3)
      {
        minage=40;
        maxage=59;
      }
      if (age == 4)
      {
        minage=60;
        maxage=1000;
      }
      viewer.filter(geschlecht,minage,maxage,minmigration,maxmigration,mineducation,maxeducation,minincome,maxincome);

    }
    if (key == '3' )
    {
      migration++;
      if (migration > 3) migration = 0;

      Migration[migration].over = true;
      Migration[migration].press();

      if (migration == 0)
      {
        minmigration = 0;
        maxmigration = 3;
      }
      if (migration == 1)
      {
        minmigration = 0;
        maxmigration = 0;
      }
      if (migration == 2)
      {
        minmigration = 1;
        maxmigration = 1;
      }
      if (migration == 3)
      {
        minmigration = 2;
        maxmigration = 2;
      }
      viewer.filter(geschlecht,minage,maxage,minmigration,maxmigration,mineducation,maxeducation,minincome,maxincome);
    }
    if (key == '4' )
    {
      education++;
      if (education > 3) education = 0;

      Bildung[education].over = true;
      Bildung[education].press();

      if (education == 0)
      {
        mineducation=0;
        maxeducation=1000;
      }
      if (education == 1)
      {
        mineducation=5;
        maxeducation=7;
      }
      if (education == 2)
      {
        mineducation=3;
        maxeducation=4;
      }
      if (education == 3)
      {
        mineducation=1;
        maxeducation=2;
      }
      viewer.filter(geschlecht,minage,maxage,minmigration,maxmigration,mineducation,maxeducation,minincome,maxincome);
    }
    if (key == '5' )
    {
      income++;
      if (income > 4) income = 0;

      Einkommen[income].over = true;
      Einkommen[income].press();

      if (income == 0)
      {
        minincome=-1;
        maxincome=1000;
      }
      if (income == 1)
      {
        minincome=3;
        maxincome=100;
      }
      if (income == 2)
      {
        minincome=2;
        maxincome=3;
      }
      if (income == 3)
      {
        minincome=1;
        maxincome=2;
      }
      if (income == 4)
      {
        minincome=0;
        maxincome=1;
      }
      viewer.filter(geschlecht,minage,maxage,minmigration,maxmigration,mineducation,maxeducation,minincome,maxincome);
    }

/*
    if (key == 's' )
    {
   //   viewer.writePoints();
   //   viewer.writeLabels();
   //   viewer.writePath();
    }
    if (key == 'm' )
    {
   //   viewer.mergePoints();
    }
    if (key == 'x' )
    {
    //  viewer.splitPoint();
    }
    */
    if (key == 'p' )
    {
      viewer.toggleMap();
    }
/*
    if (key == 'd' )
    {
     viewer.startMove();
    }
   
     if (key == 'e' )
    {
      typing = "";
      edit = true;
    }
    */
    //Virtueller Ort mit timestamp

  if (key == 'i' )  // info
  {
if (info == 1) {
    info=0;
        }
    else  {
      info =1;
    }  
  }
    
  if (key == 'h' )  // help
  {
if (info == 2) {
    info=0;
        }
    else  {
      info =2;
    }  
  }
  
  
   if (key == 'l' )  // sprache
   {
if (sprache >= 1) {
    sprache=0;
        }
    else  {
      sprache ++;
    }  
    println("sprache : " + sprache);
  }
  
    if (key == 'a' )
    {
      viewer.moveX(10);  // 10 Pixel in X Richtung bewegen
    }
    if (key == 'b' )
    {
      viewer.moveX(-10);
    }
    
        if (key == 'd' )
    {
      viewer.moveY(10);  // 10 Pixel in X Richtung bewegen
    }
    if (key == 'e' )
    {
      viewer.moveY(-10);
    }
    
    if (key == 'c' )
    {
      if (viewer.z > 0.2f)
      {
        viewer.zoomin2();
      }
      else
      {
        viewer.zoomout2();
        viewer.zoomout2();
        viewer.zoomout2();
        viewer.zoomout2();
        viewer.zoomout2();
      }
    }

  }
 }

/*
//   virtueller ORT
if (virtuell=1) {
       int sec = second();
  int minu = minute();
  int hou = hour();
  // The nf() function spaces the numbers nicely
//String t = (h,2) + ":" + (m,2) + ":" + (s,2);
  //String t = nf(h,2) + ":" + nf(m,2) + ":" + nf(s,2);
//  text(t, 10, 55);
  buf.fill (255,0,0,150);   
  buf.textFont(font5);
  int xt0 = round( (2000 - offsetX) / z);
  int yt0 = round( (1927 - offsetY) / z);
  buf.text((hou + minu + sec), xt0, yt0);
}
*/
class Button {
  int x, y; // The x- and y-coordinates
  int size; // Dimension (width and height)
  boolean over = false; // True when the mouse is over
  boolean checked = false;
  int me;
  Button[] others; // Array of all other Radio objects

  Button(int xp, int yp, int s, int m, Button[] o) {
    x = xp;
    y = yp;
    size = s;
    me = m;
    others = o;    
  }
  
  // Updates the over field every frame
  public void update() {
    if ((mouseX >= x) && (mouseX <= x + size+70) &&
        (mouseY >= y) && (mouseY <= y + size)) {
      over = true;     
    } else {
      over = false;
    }
  }

  public boolean press() {
    if (over == true) {
     // pressed = true;
      checked = true;
      for (int i = 0; i < others.length; i++) {
        if (i != me) {
          others[i].checked = false;
          }
        }
      return true;
    } else {
      return false;
    }
  }

   public void display() {
     smooth(); 
     strokeWeight(2);
     rectMode(CORNER);
     //strokeJoin(ROUND);
    noFill();     
     if (checked == true) {
        stroke (204,0,106);
    fill (204,0,106);      
   } else if (over == true) {
stroke(180,180,180);
     fill(180,180,180);
   } else {
     stroke (255);
     fill(180,180,180);
   //  cursor (HAND);
    }
   noFill(); 
     rect(x, y, size+102, size+3);
  }
}

// Intersectional Map



Integer[] EU_List = {15,20,27,28,33,35,36,40,49,52,73,78,79,96,107,108,110,115,123,124,126,138,145,152,155};

class Point
{
  public int id;
  public float x, y;
  public short count;
  public short mark;
  public ArrayList labels = new ArrayList();
  public ArrayList lcount = new ArrayList();

  public short[] gender = {0,0,0};
  public short[] migration = {0,0,0};
  public short[] income = {0,0,0,0,0};
  public short[] education = {0,0,0,0};
  public short[] age = {0,0,0,0};
  public float heter;
}

class Pair
{
  public Point a, b;
  public short count;
  public float length;
}

class Path
{
  public ArrayList points = new ArrayList();
  public ArrayList labels = new ArrayList();
  public ArrayList pairs = new ArrayList();
}

class Poll
{
  public short id;
  public byte gender;
  public byte age;
  public byte education;
  public int migration;
  public byte income;
  public Path[] path = new Path[2];
  public float currentPosition = 0;
  public int currentPath = 0;
  public int currentPoint = 0;
  public float x = 0;
  public float y = 0;
  public float speed = 0;
  Poll()
  {
    path[0] = new Path();
    path[1] = new Path();
  }
  public void randomize(float r)
  {
    x += r * random(-1,1)/10;
    y += r * random(-1,1)/10;
    if (x > r) x *=0.9f;
    if (x < -r) x *=0.9f;
    if (y > r) y *=0.9f;
    if (y < -r) y *=0.9f;
  }
}

class Label
{
  public short id;
  public String text;
  public int count;
}

// Point[] point = new Point[10000];
// Poll[]  poll  = new Poll[1000];
// Path[]  path  = new Path[100000];
// Label[] label = new Label[1000];

class Viewer
{
  
  PFont font;
  
  private int x, y, w, h;
  public float z = 1;
  private float offsetX, offsetY, Width, Height;
  private boolean dirty, moving = false, showmap = false, movement_enabled = false;

  private PGraphics buf;
  private PGraphics pathbuf;
  private PImage image;

  private int mode = 0; // stuff like View, Move-Point, Merge-Point, ....
  private Point selected = null;
  private Point temp = null;

  private ArrayList points;
  private ArrayList pairs;
  private ArrayList polls;
  private ArrayList labels;

  Viewer(int x, int y ,int w, int h)
  {
    this.x = x; this.y = y;
    this.w = w; this.h = h;
    image = loadImage("karte.png");
    buf = createGraphics(w, h, JAVA2D);
    pathbuf = createGraphics(image.width, image.height, JAVA2D);
    offsetX = image.width/2 - w/2;
    offsetY = image.height/2 - h/2;
    clip();


    points = new ArrayList();
    pairs  = new ArrayList();
    polls  = new ArrayList();
    labels  = new ArrayList();
    readLabels();
    readPoints();
    readPolls();
    readPath();
    calcPointColor();
    drawPathBuf();
  }

  public void draw()
  {
    int n;
    //ORTSPUNKTE TEXT LABEL
    buf.textFont(font1);
    buf.beginDraw();
    // Hintergrund l\u00f6schen (weiss)
    buf.background(255,255,255);
    // KARTE ZEICHNEN
    if (showmap == true)
    {
      buf.image(image.get(round(offsetX), round(offsetY), round(Width), round(Height)), 0, 0 , w, h);
    }
    
    else
    {
      // gebufferte Wege zeichnen
      buf.image(pathbuf.get(round(offsetX), round(offsetY), round(Width), round(Height)), 0, 0 , w, h);
    }

    // Wege: n auf Null setzen um auszuschalten
    n= pairs.size();
    n=0;
    // WEGFARBE definieren
    buf.noFill();
    buf.stroke(164,150,96,40);
    buf.strokeWeight(1/z);
    buf.strokeCap(ROUND);
    buf.strokeJoin(ROUND);
    
    for(int i = 0; i < n ; i++)
    {
      Pair P = (Pair)pairs.get(i);
      int x1 = round((P.a.x - offsetX) / z);
      int y1 = round((P.a.y - offsetY) / z);
      int x2 = round((P.b.x - offsetX) / z);
      int y2 = round((P.b.y - offsetY) / z);
      if ( ( ( x1 < w ) && ( x1 > 0 ) && ( y1 < h ) && ( y1 > 0 ) ) || ( ( x2 < w ) && ( x2 > 0 ) && ( y2 < h ) && ( y2 > 0 ) ) )
      {
        // Liniendicke
        if (P.count > 0)
        {
          buf.smooth();
          buf.strokeWeight(0.1f * sqrt(P.count)/z);
          buf.beginShape();
          buf.vertex(x1,y1);
          buf.vertex(x2,y2);
          buf.endShape();
        }
      }
    }


    n = points.size();
    buf.noStroke();
  
    for(int i = 0; i < n ; i++)
    {
      Point P = (Point)points.get(i);
      int x = round((P.x - offsetX) / z);
      int y = round((P.y - offsetY) / z);
      if ( ( x < w ) && ( x > 0 ) && ( y < h ) && ( y > 0 ) )
      {
        // Punktgr\u00f6sse
        float r;
        if (P.count > 0)
        {
          // Punkte mit Bezeichnung
          r = 1.5f * sqrt(P.count + 4)/z;
          //r = 4 * sqrt(P.count + 0.2)/z;  //FORMEL ver\u00e4ndert
        }
        else
        {
          // Punkte ohne Bezeichnung
          // r=1/z;
          r = 0;
        }
        if (P.mark == 0)
        {
          buf.fill(0,0,255);
        } else if (P.mark == 1)
        {
          buf.fill(128,128,128);
        } else if (P.mark == 2)
        {
          buf.fill(225,150,0);
        } else if (P.mark == 3)
        {
          buf.fill(0,225,0);
        } else if (P.mark == 4)
        {
          buf.fill(0,0,0);
        }

        if (P == selected)
        {
            
                buf.fill(255,0,0);  //Markierungsfarbe
                buf.ellipse(x, y , r*3, r*3);
                buf.fill(255,255,255);  //Markierungsfarbe
                buf.ellipse(x, y , r*1.1f, r*1.1f);
        }
        else if (P == temp)
        {
          buf.fill(255,255,255); //kein Geschlecht Punkte
        }
        
        // ORTSPUNKTE - Farbe
        buf.smooth();
      //  buf.fill(204,0,102, P.heter * 10);
  buf.fill(204,0,102, P.heter * 4.2f);
        //buf.fill(177,0,93, P.heter * 2.5);
        buf.strokeWeight(1);
        buf.stroke(177,0,93,10);


     
        buf.ellipse(x, y , r, r);

        if (( z < 0.3f ) && (r > 0))
        {
          int m = P.labels.size();
          for(int j = 0 ; j < m ; ++j)
          {
            Label L = (Label)P.labels.get(j);
            if (L.id > 0)
            //ORTSPUNKTE - Textlabel     
            {
               buf.fill(82,59,61);
              buf.text(L.text, x+r*0.5f, y-r*0.5f+j*12);
            }
          }
        }
      }
    }

    n = polls.size();
    // buf.stroke(0);
    buf.strokeWeight(1);
    buf.rectMode(CENTER);
    float r = 5/z;
    for(int i = 0; i < n ; ++i)
    {
      Poll poll = (Poll)polls.get(i);
      if (poll.path[poll.currentPath].pairs.size() > 1)
      {
        float scale = 1.0f;
        Pair pair = (Pair)poll.path[poll.currentPath].pairs.get(poll.currentPoint);
        Label label = (Label)poll.path[poll.currentPath].labels.get(poll.currentPoint);
        float l = pair.length;
        if (poll.currentPosition > l)
        {
          poll.currentPoint += 1;
          if (poll.currentPoint >= poll.path[poll.currentPath].pairs.size())
          {
            poll.currentPoint = 0;
            poll.currentPath = 1 - poll.currentPath;
          }
          if (poll.currentPoint >= poll.path[poll.currentPath].pairs.size())
          {
            poll.currentPoint = 0;
            poll.currentPath = 1 - poll.currentPath;
          }
          pair = (Pair)poll.path[poll.currentPath].pairs.get(poll.currentPoint);
          label = (Label)poll.path[poll.currentPath].labels.get(poll.currentPoint);

          poll.currentPosition -= l;
          if (label.id > 0)
          {
            poll.currentPosition /= 10;
          }
          l = pair.length;
        }
        Point A = (Point)poll.path[poll.currentPath].points.get(poll.currentPoint);
        Point B = (Point)poll.path[poll.currentPath].points.get(poll.currentPoint + 1);
        int x = round(( (A.x + poll.x + poll.currentPosition * (B.x - A.x)/l) - offsetX) / z);
        int y = round(( (A.y + poll.y + poll.currentPosition * (B.y - A.y)/l) - offsetY) / z);

        if ((label.id > 0) && ( poll.currentPosition < 2.0f ))
        {
          scale = 1.0f + 1.0f * poll.currentPosition * ( 2.0f - poll.currentPosition );
          poll.currentPosition += ( 0.1f * poll.speed );
        }
        else
        {
          scale = 1.0f;
          poll.currentPosition += poll.speed;
        }
        if ( ( x < w ) && ( x > 0 ) && ( y < h ) && ( y > 0 ) && ( poll.speed > 0 ) )
        {
                  if ((selected != null) && (A.id == selected.id) && (poll.speed == 5.0f))          
          {
            poll.currentPosition = 0.0f;
            scale = 1.5f;
            poll.randomize(10);
          }
          else
          {
            // poll.speed=1;
            // poll.randomize(1);
          }

          // Farbe anhand des Geschlechtes
           if (poll.gender == 2)
          {
         buf.stroke(180,216,0,255);
            buf.fill(180,216,0,120);
          }
          else if (poll.gender == 1)
          {
            buf.stroke(0,178,235,255); 
            buf.fill(0,178,235,120);
          
          }
          else
          {
            buf.stroke(255,255,255);
            buf.fill(255,255,255);
          }

          // Form nach Migration
          if (poll.migration == 0)
          {
            buf.rect(x,y,r*scale,r*scale);
          }
          else if (poll.migration == 1)
          {
            buf.triangle(x-r*scale*0.55f, y+r*scale*0.55f, x+r*scale*0.55f, y+r*scale*0.55f, x, y-r*scale*0.6f);
          }
          else
          {
            buf.quad(x, y+r*scale*0.7f, x+r*scale*0.35f, y, x, y-r*scale*0.7f, x-r*scale*0.35f,y);
          }
        }
      }
    }
    
    if (true)
    {
      //Bezirke 
      buf.fill (108,194,175,150);   
      buf.textFont(font5);
      int xb0 = round( (1830 - offsetX) / z);
      int yb0 = round( (1927 - offsetY) / z);
      buf.text("INNERE STADT", xb0, yb0);
      int xb1 = round( (1200 - offsetX) / z);
      int yb1 = round( (522 - offsetY) / z);
      buf.text("ANDRITZ", xb1, yb1);
      int xb2 = round( (1650 - offsetX) / z);
      int yb2 = round( (1370 - offsetY) / z);
      buf.text("GEIDORF", xb2, yb2);
      int xb3 = round( (2197 - offsetX) / z);
      int yb3 = round( (2087 - offsetY) / z);
      buf.text("ST. LEONHARD", xb3, yb3);
      int xb5 = round( (1056 - offsetX) / z);
      int yb5 = round( (1897 - offsetY) / z);
      buf.text("LEND", xb5, yb5);
      int xb6 = round( (1210 - offsetX) / z);
      int yb6 = round( (2637 - offsetY) / z);
      buf.text("GRIES", xb6, yb6);
      int xb7 = round( (2040 - offsetX) / z);
      int yb7 = round( (2867 - offsetY) / z);
      buf.text("JAKOMINI", xb7, yb7);
      int xb8 = round( (2062 - offsetX) / z);
      int yb8 = round( (3625 - offsetY) / z);
      buf.text("LIEBENAU", xb8, yb8);
      int xb9 = round( (3036 - offsetX) / z);
      int yb9 = round( (2987 - offsetY) / z);
      buf.text("ST.PETER", xb9, yb9);
      int xb10 = round( (3008 - offsetX) / z);
      int yb10 = round( (2242 - offsetY) / z);
      buf.text("WALTENDORF", xb10, yb10);
      int xb11 = round( (3256 - offsetX) / z);
      int yb11 = round( (1811 - offsetY) / z);
      buf.text("RIES", xb11, yb11);
      int xb12 = round( (2728 - offsetX) / z);
      int yb12 = round( (733 - offsetY) / z);
      buf.text("MARIATROST", xb12, yb12);
      int xb13 = round( (382 - offsetX) / z);
      int yb13 = round( (1247 - offsetY) / z);
      buf.text("G\u00d6STING", xb13, yb13);
      int xb14 = round( (262 - offsetX) / z);
      int yb14 = round( (2155 - offsetY) / z);
      buf.text("EGGENBERG", xb14, yb14);
      int xb15 = round( (473 - offsetX) / z);
      int yb15 = round( (3010 - offsetY) / z);
      buf.text("WETZELSDORF", xb15, yb15);
      int xb16 = round( (522 - offsetX) / z);
      int yb16 = round( (4057 - offsetY) / z);
      buf.text("STRASSGANG", xb16, yb16);
      int xb17 = round( (1576 - offsetX) / z);
      int yb17 = round( (4000 - offsetY) / z);
      buf.text("PUNTIGAM", xb17, yb17);
      }
      
          

    buf.endDraw();
    image(buf.get(0,0,w,h),x,y,w,h);
  }

private void drawPathBuf()
  {
    int n;
    pathbuf.beginDraw();
    pathbuf.background(255,255,255);
    pathbuf.noFill();
    pathbuf.stroke(164,150,96,40);
    pathbuf.strokeWeight(1/z);
    pathbuf.strokeCap(ROUND);
    pathbuf.strokeJoin(ROUND);
    pathbuf.smooth();
    n= pairs.size();
    for(int i = 0; i < n ; i++)
    {
      Pair P = (Pair)pairs.get(i);
      pathbuf.strokeWeight(0.1f * sqrt(P.count));
      pathbuf.beginShape();
      pathbuf.vertex(P.a.x,P.a.y);
      pathbuf.vertex(P.b.x,P.b.y);
      pathbuf.endShape();
    }
    pathbuf.endDraw();
  }


public void drawPointInfo(int x, int y, int lang)
  {
    if (selected == null) return;
    fill(200,200,200,200);
    rect(0,0, 250, 500);


    
//---------------------------------------------------------------
// Pie chart: Geschlecht
//---------------------------------------------------------------
strokeWeight(1);
stroke(180,216,0,255);
fill(180,216,0,120);
arc (x+50, y+110,60, 60, - HALF_PI,TWO_PI * selected.gender[2] / selected.count - HALF_PI); //weiblich

stroke(0,178,235,255); 
fill(0,178,235,120);
arc (x+50, y+110, 60, 60, - TWO_PI * selected.gender[1] / selected.count - HALF_PI, - HALF_PI ); //m\u00e4nnlich

//Beschriftungen Tortendiagramm / Balkendiagramm
fill(177,0,93);
textFont(font3);
text ("GESCHLECHT:", x+10, y+70);
text ("ALTER:", x+10, y+160);
text ("MIGRATION:", x+10, y+250);
text("BILDUNG:", x+10,y+325);
text("EINKOMMEN:", x+10,y+400);

//Ortsname
          fill(255,0,0);
          int m = selected.labels.size();
          for(int j = 0 ; j < m ; ++j)
          {
            Label L = (Label)selected.labels.get(j);
            if (L.id > 0)
                     {
              text(L.text, x+10,y+10);
            }
          }

fill(0,0,0,190);
textFont(font0);
//text ("Heterogenit\u00e4t:  " + selected.heter, x+10, y+30);
text ("Heterogenit\u00e4t:  " + nf(selected.heter,2,1), x+10, y+30);
text ("Personenfrequenz:  " + selected.count, x+10, y+45);
text ("14-19", x+10, y+180);
text ("20-39", x+10, y+195);
text ("40-59", x+10, y+210);
text ("60 +", x+10, y+225);
text ("A", x+10, y+270);
text ("EU", x+10, y+285);
text ("N-EU", x+10, y+300);
text ("niedrig", x+10, y+345);
text ("mittel", x+10, y+360);
text ("hoch", x+10, y+375);
text ("s. niedr.", x+10, y+420);
text ("niedrig", x+10, y+435);
text ("mittel", x+10, y+450);
text ("hoch", x+10, y+465);

fill(180,180,0);
text("Frauen: ", x+110, y +120);
fill(0,178,235);
text("M\u00e4nner: ", x+110, y +135);

fill(0,0,0,190);
rectMode (CORNER);
noFill();
strokeWeight(1);
stroke(0,0,0,180);

//Geschlecht
text (nf(100.0f * selected.gender[1] / selected.count,2,1) ,  x+ 150, y + 135);
text (nf(100.0f * selected.gender[2] / selected.count,2,1) ,  x+ 150, y + 120);

//ALTER
if  (selected.age[0] > 0) {
rect(x+50, y+170, 150.0f*selected.age[0] / selected.count, 10);
text (nf(100.0f * selected.age[0] / selected.count,2,1) ,  x+ 55 + 150.0f*selected.age[0] / selected.count, y + 180);
}
if  (selected.age[1] > 0) {
rect(x+50, y+185, 150.0f*selected.age[1] / selected.count, 10);    
text (nf(100.0f * selected.age[1] / selected.count,2,1) ,  x+ 55 + 150.0f*selected.age[1] / selected.count, y + 195);
}
if  (selected.age[2] > 0) {
rect(x+50, y+200, 150.0f*selected.age[2] / selected.count, 10);    
text (nf(100.0f * selected.age[2] / selected.count,2,1) ,  x+ 55 + 150.0f*selected.age[2] / selected.count, y + 210);
}
if  (selected.age[3] > 0) {
rect(x+50, y+215, 150.0f*selected.age[3] / selected.count, 10);    
text (nf(100.0f * selected.age[3] / selected.count,2,1) ,  x+ 55 + 150.0f*selected.age[3] / selected.count, y + 225);
}

//MIGRATION
if  (selected.migration[0] > 0) {
rect(x+50, y+260, 150.0f*selected.migration[0] / selected.count, 10);
text (nf(100.0f * selected.migration[0] / selected.count,2,1) ,  x+ 55 + 150.0f*selected.migration[0] / selected.count, y +270);
}
if  (selected.migration[1] > 0) {
rect(x+50, y+275, 150.0f*selected.migration[1] / selected.count, 10);    
text (nf(100.0f * selected.migration[1] / selected.count,2,1) ,  x+ 55 + 150.0f*selected.migration[1] / selected.count, y + 285);
}
if  (selected.migration[2] > 0) {
rect(x+50, y+290, 150.0f*selected.migration[2] / selected.count, 10);    
text (nf(100.0f * selected.migration[2] / selected.count,2,1) ,  x+ 55 + 150.0f*selected.migration[2] / selected.count, y + 300);
}

//BILDUNG
if  (selected.education[1] > 0) {
rect(x+50, y+335, 150.0f*selected.education[1] / selected.count, 10);
text (nf(100.0f * selected.education[1] / selected.count,2,1) ,  x+ 55 + 150.0f*selected.education[1] / selected.count, y +345);
}
if  (selected.education[2] > 0) {
rect(x+50, y+350, 150.0f*selected.education[2] / selected.count, 10);    
text (nf(100.0f * selected.education[2] / selected.count,2,1) ,  x+ 55 +150.0f*selected.education[2] / selected.count, y + 360);
}
if  (selected.education[3] > 0) {
rect(x+50, y+365, 150.0f*selected.education[3] / selected.count, 10);    
text (nf(100.0f * selected.education[3] / selected.count,2,1) ,  x+ 55 + 150.0f*selected.education[3] / selected.count, y + 375);
}

//EINKOMMEN
if  (selected.income[1] > 0) {
rect(x+50, y+410, 150.0f*selected.income[1] / selected.count, 10);
text (nf(100.0f * selected.income[1] / selected.count,2,1) ,  x+ 55 + 150.0f*selected.income[1] / selected.count, y + 420);
}
if  (selected.income[2] > 0) {
rect(x+50, y+425, 150.0f*selected.income[2] / selected.count, 10);    
text (nf(100.0f * selected.income[2] / selected.count,2,1) ,  x+ 55 + 150.0f*selected.income[2] / selected.count, y + 435);
}
if  (selected.income[3] > 0) {
rect(x+50, y+440, 150.0f*selected.income[3] / selected.count, 10);    
text (nf(100.0f * selected.income[3] / selected.count,2,1) ,  x+ 55 +150.0f*selected.income[3] / selected.count, y + 450);
}
if  (selected.income[4] > 0) {
rect(x+50, y+455, 150.0f*selected.income[4] / selected.count, 10);    
text (nf(100.0f * selected.income[4] / selected.count,2,1) ,  x+ 55 + 150.0f*selected.income[4] / selected.count, y + 465);
}

  } 
  

  public void toggleMap()
  {
    showmap = ! showmap;
  }
  public void mousePressed()
  {
    // findPoint(getX(), getY(), max(15.0 * z, 6.0) );
    Point P = findPoint(getX(), getY(), max(15.0f * z, 6.0f) );
    if ( P == null)
    {
      selected = null;
    }
    else
    {
      selected = P;
      println("Found Point " + P.id + " (" + P.count + "x)");
      // splitPairs(P,getX(), getY(), max(10.0 * z, 4.0));
      int n = P.labels.size();
      for(int i = 0; i < n ; i++)
      {
        Label L = (Label)P.labels.get(i);
        Integer count = (Integer)P.lcount.get(i);
        println("   " + L.text + " (" + count + "x)");
      }
      // Statistik
      println("   gender:    " + P.gender[0] + " , " + P.gender[1] + " , " + P.gender[2] );
      println("   migration: " + P.migration[0] + " , " + P.migration[1] + " , " + P.migration[2] );
      println("   age:       " + P.age[0] + " , " + P.age[1] + " , " + P.age[2] + " , " + P.age[3]);
      println("   income:    " + P.income[0] + " , " + P.income[1] + " , " + P.income[2] + " , " + P.income[3] + " , " + P.income[4]);
      println("   education: " + P.education[0] + " , " + P.education[1] + " , " + P.education[2] + " , " + P.education[3]);
      println("   -> color:  " + P.heter);

      // Find Polls with that point
      n = polls.size();
      for(int i = 0; i < n ; i++)
      {
        Poll poll = (Poll)polls.get(i);
        for(int j=0; j < 2 ; ++j)
        {
          int m = poll.path[j].points.size();
          for(int k=0; k < m ; ++k)
          {
            Point point = (Point)poll.path[j].points.get(k);
            Label label = (Label)poll.path[j].labels.get(k);
            if ((point == selected) && (label.id > 0) && (poll.speed > 0.1f))
            {
              poll.speed = 5.0f;
            }
          }
        }
        
      }

    }
    // int i = findPair(getX(), getY(), max(15.0 * z, 6.0) );
  }

  public Point findPoint(float x, float y, float r)
  {
    Point point = null;
    float rr = r*r;
    int n = points.size();
    for(int i = 0; i < n ; i++)
    {
      Point P = (Point)points.get(i);
      float rtmp = ((P.x - x)*(P.x - x) + (P.y -y)*(P.y -y));
      if (( rtmp < rr ) && (P.labels.size() > 1))
      {
        point = P;
        rr = rtmp;
      }
    }
    return point;
  }
  
  public void splitPairs(Point S, float x, float y, float r)
  {
    int n = pairs.size();
    for(int i = 0; i < n ; i++) {
      Pair P = (Pair)pairs.get(i);
      float ll = ( (P.a.x-P.b.x)*(P.a.x-P.b.x)+(P.a.y-P.b.y)*(P.a.y-P.b.y) );
      float m = ( (P.a.x-P.b.x)*(P.a.x-x)+(P.a.y-P.b.y)*(P.a.y-y) ) / ll;
      float dist = ( (P.a.x - P.b.x) * (P.a.y - y)-(P.a.y - P.b.y) * (P.a.x - x) ) / ( sqrt(ll));
      dist = abs(dist);

      if ((dist < r ) && (m < 1) && (m > 0) )
      {
        if ((P.a != S ) && (P.b != S))
        {
          splitPair(P,S);
        }
      }
    }
  }

  public int findPair(float x, float y, float r)
  {
    int index= -1;
    int n = pairs.size();
    for(int i = 0; i < n ; i++) {
      Pair P = (Pair)pairs.get(i);
      float ll = ( (P.a.x-P.b.x)*(P.a.x-P.b.x)+(P.a.y-P.b.y)*(P.a.y-P.b.y) );
      float m = ( (P.a.x-P.b.x)*(P.a.x-getX())+(P.a.y-P.b.y)*(P.a.y-getY()) ) / ll;
      float dist = ( (P.a.x - P.b.x) * (P.a.y - getY())-(P.a.y - P.b.y) * (P.a.x - getX()) ) / ( sqrt(ll));
      dist = abs(dist);
      
      if ((dist < r ) && (m < 1) && (m > 0) ) {
        r=dist;
        index=i;
      }
    }
    println("findPair r= " + r);
    if (index > -1)
    {
      Pair pair = (Pair)pairs.get(index);
      Point point = (Point)points.get(100);
      splitPair(pair, point);
    }
    return index;
  }

  private void autoSelect()
  {
    Point P = findPoint(offsetX + (w/2-x) * z, offsetY + (h/2-y) * z, 100.0f * z );
    if ( P == null )
    {
      selected = null;
    }
    else
    {
      selected = P;
    }
  }

  public void moveX(float x)
  {
    offsetX -= x*z;
    clip();
    autoSelect();
  }

  public void moveY(float y)
  {
    offsetY -= y*z;
    clip();
    autoSelect();
  }

  public void startMove()
  {
    movement_enabled = true;
  }

  public void mouseDragged()
  {
    if ( mouseButton == LEFT )
    {
      if ( (selected != null) && ( movement_enabled == true) )
      {
        selected.x -= (pmouseX - mouseX) * z;
        selected.y -= (pmouseY - mouseY) * z;
      }
      else
      {
        offsetX += (pmouseX - mouseX) * z;
        offsetY += (pmouseY - mouseY) * z;
        clip();
      }
    }
  }

  public void mouseReleased()
  {
    movement_enabled = false;
    // println ("mouseReleased");
  }

  // Zoom relativ zur Mitte ( f\u00fcr Tastatur )
  public void zoomin2()
  {
    z/=1.5f;
    offsetX += ((w/2-x) * z * 0.5f);
    offsetY += ((h/2-y) * z * 0.5f);
    clip();
    autoSelect();
  }

  public void zoomout2()
  {
    // println ("zoom out");
    if (z < 2)
    {
      offsetX -= ((w/2-x) * z * 0.5f);
      offsetY -= ((h/2-y) * z * 0.5f);
      z*=1.5f;
      clip();
    }
  }

  // Zoom relativ zu Maus
  public void zoomin()
  {
    // println ("zoom in");
    z/=1.1f;
    offsetX += ((mouseX-x) * z * 0.1f);
    offsetY += ((mouseY-y) * z * 0.1f);
    clip();
  }

  public void zoomout()
  {
    // println ("zoom out");
    if (z < 2)
    {
      offsetX -= ((mouseX-x) * z * 0.1f);
      offsetY -= ((mouseY-y) * z * 0.1f);
      z*=1.1f;
      clip();
    }
  }

  private void clip()
  {
    if (offsetX < 0 ) offsetX = 0;
    if (offsetY < 0 ) offsetY = 0;
    if (offsetX > (image.width - w*z) ) offsetX = (image.width - w*z);
    if (offsetY > (image.height - h*z) ) offsetY = (image.height - h*z);
    Width = (w*z);
    Height = (h*z);
    redraw();
  }

  public float getX() {
    return (offsetX + (mouseX-x) * z);
  }

  public float getY() {
    return (offsetY + (mouseY-y) * z);
  }

  private void readPoints()
  { 
    try {
      BufferedReader reader = createReader("points.txt");
      String line = null;
      Label label = (Label)labels.get(0);
      Integer lcount = 0;
      while ((line = reader.readLine()) != null)
      {
        String[] column = split(line,TAB);
        Point P = new Point();
        P.id    = PApplet.parseInt(column[0]);
        P.x     = PApplet.parseFloat(column[1]);
        P.y     = PApplet.parseFloat(column[2]);
        P.count = 0;
        if(column.length > 3)
        {
          P.mark  = (short)PApplet.parseInt(column[3]);
        }
        else
        {
          P.mark=0;
        }
        P.labels  = new ArrayList();
        P.lcount  = new ArrayList();
        P.labels.add(label);
        P.lcount.add(lcount);
        points.add(P);
      } 
    } catch (IOException ioe) 
    {
      System.out.println( "IO error: " + ioe );
    }
    println("* " + points.size() + " points read ...");
  }

  private void renumberPoints()
  {
    int n = points.size();
    Point P = null;
    for(int i = 0; i < n ; i++)
    {
      P = (Point)points.get(i);
      P.id = (short)i;
    }
  }

  private void writePoints()
  {
    renumberPoints();
    println("writing points.txt");
    PrintWriter writer = createWriter("data/points.txt");
    int n = points.size();
    Point P = null;
    for(int i = 0; i < n ; i++)
    {
      P = (Point)points.get(i);
      writer.println(P.id + "\t" + P.x + "\t" + P.y + "\t" + P.mark);
    }
    writer.flush();
    writer.close();
  }

  private Point findPoint(int id)
  {
    int n = points.size();
    int index = -1;
    Point P = null;
    Label L = null;
    // FIXME: This only works if Point table does not have any gaps
    P = (Point)points.get(id);
    if (P.id == id) return P;
    // FIXME: Otherwise loop through table to find point
    for(int i = 0; i < n ; i++)
    {
      P = (Point)points.get(i);
      if (P.id == id)
      {
        println("point " + id + " = points.get()" + i + ");");
        return P;
      }
    }
    println("Panic - point " + id + " not found !!!");
    return null;
  }

  private Pair findOrAddPair(Point a, Point b)
  {
    if (a.id > b.id)
    {
      Point tmp = a;
      a = b;
      b = tmp;
    }
    int n = pairs.size();
    int index = -1;
    Pair P = null;
    for(int i = 0; i < n ; i++)
    {
      P = (Pair)pairs.get(i);
      if ((P.a == a) && (P.b == b)) return P;
    }
    P = new Pair();
    P.a = a;
    P.b = b;
    P.length = sqrt( (a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y) );
    pairs.add(P);
    return P;
  }

  private void readPolls()
  { 
    try {
      BufferedReader reader = createReader("polls.txt");
      String line = null;
      while ((line = reader.readLine()) != null)
      {
        // ID Geschlecht Alter Ausbildung Einkommen Personen Kinder Taetigkeit Nationalitaet1,2 Nat_Eltern1,2,3,4
        String[] column = split(line,TAB);
        Poll P = new Poll();
        P.id     = (short)PApplet.parseInt(column[0]);
        P.gender = (byte) PApplet.parseInt(column[1]);
        P.age    = (byte) PApplet.parseInt(column[2]);
        P.education = (byte) PApplet.parseInt(column[3]);

//         int einkommen = 0;
//         switch ((byte) int(column[4])) // Einkommen
//         {
//           case  1: einkommen =  350; break;
//           case  2: einkommen =  850; break;
//           case  3: einkommen = 1250; break;
//           case  4: einkommen = 1750; break;
//           case  5: einkommen = 2250; break;
//           case  6: einkommen = 2750; break;
//           case  7: einkommen = 3250; break;
//           case  8: einkommen = 3750; break;
//           case  9: einkommen = 4250; break;
//           case 10: einkommen = 4750; break;
//         }

        int personen = (byte) PApplet.parseInt(column[5]);
        int kinder   = (byte) PApplet.parseInt(column[6]);
        
        
        // Nat: 8 - 13
        P.migration = 0;
        for(int i = 8; i < 14 ; i++)
        {
          int m = 0;
          Boolean a,b;
          a = PApplet.parseInt(column[i]) != 0 ;
          b = PApplet.parseInt(column[i]) != 100 ;
          if( a && b  )
          {
            m = 2;
            for(int j = 0; j < EU_List.length; j++)
            {
              if(PApplet.parseInt(column[i]) == EU_List[j])
              {
                m = 1;
              }
            }
          }
          P.migration = max(P.migration,m);
        }
        // println ("ID: " + P.id + " Migration: " + P.migration);

        // P.income = einkommen / ( 0.5 + personen * 0.5 - kinder * 0.2 ) / 926;
        // println ("ID: " + P.id + " Einkommen-ID: " + column[4] + " Personen:" + personen + " Kinder:" + kinder + " -> " + P.income);
        
        // Ignoriere obige Berechnung und verwende Spalte mit vorberechneten Werten
        P.income = (byte) PApplet.parseInt(column[14]);
        
        polls.add(P);
      } 
    } catch (IOException ioe) 
    {
      System.out.println( "IO error: " + ioe );
    }
    println("* " + polls.size() + " polls read ...");
  }

  private Poll findPoll(int id)
  {
    int n = polls.size();
    int index = -1;
    Poll P = null;
    for(int i = 0; i < n ; i++)
    {
      P = (Poll)polls.get(i);
      if (P.id == id) return P;
    }
    return null;
  }

  private void readLabels()
  {
    // Column 0 : id
    // Column 1 : poll
    try {
      BufferedReader reader = createReader("labels.txt");
      int id;
      String line = null;
      while ((line = reader.readLine()) != null)
      {
        String[] column = split(line,TAB);
        Label L = new Label();
        L.id  = (short) PApplet.parseInt(column[0]);
        L.text = column[1];
        labels.add(L);
      } 
    } catch (IOException ioe) 
    {
      System.out.println( "IO error: " + ioe );
    }
    println("* " + labels.size() + " labels read ...");
  }

  private void renumberLabels()
  {
    int n = labels.size();
    Label L = null;
    for(int i = 0; i < n ; i++)
    {
      L = (Label)labels.get(i);
      if (L.count == 0)
      {
        labels.remove(i);
        --i;
        --n;
      }
      else
      {
        L.id = (short)i;
      }
    }
  }

  private void writeLabels()
  {
    renumberLabels();
    println("writing labels.txt");
    PrintWriter writer = createWriter("data/labels.txt");
    int n = labels.size();
    Label L = null;
    for(int i = 0; i < n ; i++)
    {
      L = (Label)labels.get(i);
      writer.println(L.id + "\t" + L.text);
    }
    writer.flush();
    writer.close();
  }
  
  private Label findLabel(int id)
  {
    int n = labels.size();
    int index = -1;
    Label L = null;
    // FIXME: This only works if Point table does not have any gaps
    if (id < n)
    {
      L = (Label)labels.get(id);
      if (L.id == id) return L;
    }
    // FIXME: Otherwise loop through table to find point
    for(int i = 0; i < n ; i++)
    {
      L = (Label)labels.get(i);
      if (L.id == id) return L;
    }
    return null;
  }

  private void addLabelToPoint(Label label, Point point)
  {
    int n = point.labels.size();
    Integer count = 1;
    for(int i = 0; i < n ; i++)
    {
      Label L = (Label)point.labels.get(i);
      if (L.id == label.id)
      {
        count = (Integer)point.lcount.get(i);
        count++;
        point.lcount.set(i,count);
        return;
      }
    }
    point.labels.add(label);
    point.lcount.add(count);
  }

  private void statisticsReset()
  {
    int n = points.size();
    Point P = null;
    for(int i = 0; i < n ; i++)
    {
      P = (Point)points.get(i);
      for (int j = 0; j < P.gender.length; j++)
      {
        P.gender[j] = 0;
      }
      for (int j = 0; j < P.migration.length; j++)
      {
        P.migration[j] = 0;
      }
      for (int j = 0; j < P.income.length; j++)
      {
        P.income[j] = 0;
      }
      for (int j = 0; j < P.education.length; j++)
      {
        P.education[j] = 0;
      }
      for (int j = 0; j < P.age.length; j++)
      {
        P.age[j] = 0;
      }
    }
  }

  private void statisticsOnPoint(Poll poll, Point point, Label label)
  {
    if (label.id > 0)
    {
      point.gender[poll.gender]++;
      point.migration[poll.migration]++;

      int age = 0;
      if (poll.age < 20)
      {
        age = 0;
      } 
      else if (poll.age < 40)
      {
        age = 1;
      }
      else if (poll.age < 60)
      {
        age = 2;
      } 
      else
      {
        age = 3;
      }
      point.age[age]++;

      point.income[poll.income]++;

      int education = 0;
      if ( poll.education == 1 )
      {
        education = 1;
      }
      else if ( (poll.education >= 2) && (poll.education <= 4) )
      {
        education = 2;
      }
      else if ( (poll.education >= 5) && (poll.education <= 7) )
      {
        education = 3;
      }
      point.education[education]++;
    }
  }

  private void readPath()
  {
    // Column 0 : id
    // Column 1 : poll
    // Column 2 : path
    // Column 3 : label
    // Column 4 : point
    int count = 0;
    try {
      BufferedReader reader = createReader("path.txt");
      Poll poll = findPoll(1);
      Point point = null;
      Label label = null;
      Point lastpoint = null;
      Pair  pair = null;
      String line = null;
      while ((line = reader.readLine()) != null)
      {
        String[] column = split(line,TAB);
        if (poll.id != PApplet.parseInt(column[1]))
        {
          poll = findPoll(PApplet.parseInt(column[1]));
        }
        lastpoint = point;

        // Punkt einf\u00fcgen
        point = findPoint(PApplet.parseInt(column[4]));
        //++point.count;
        poll.path[PApplet.parseInt(column[2])].points.add(point);

        // Label Poll einf\u00fcgen
        label = findLabel(PApplet.parseInt(column[3]));
        //++label.count;
        poll.path[PApplet.parseInt(column[2])].labels.add(label);

        // Punkt - Label verkn\u00fcpfung
        addLabelToPoint(label,point);

        // Statistik an Punkt
        statisticsOnPoint(poll,point,label);

        // Pair einf\u00fcgen
        if (PApplet.parseInt(column[0]) > 0)
        {
          pair = findOrAddPair(point,lastpoint);
          poll.path[PApplet.parseInt(column[2])].pairs.add(pair);
          //++pair.count;
        }
        ++count;
      }
    } catch (IOException ioe)
    {
      System.out.println( "IO error: " + ioe );
    }
    println("* " + count + " pairs read ...");
    println("* " + pairs.size() + " unique pairs found ...");
  }

  private void calcPointColor()
  {
    int n = points.size();
    Point P = null;
    for(int i = 0; i < n ; i++)
    {
      P = (Point)points.get(i);
      float a,b = 0;

      a = P.gender[1] + P.gender[2] + 0.0001f;
      a /= 2;
      b += pow(P.gender[1] * P.gender[2] / (a*a),4.0f/2.0f);

      a = P.age[0] + P.age[1] + P.age[2] + P.age[3] + 0.0001f;
      a /= 4;
      b += pow(P.age[0] * P.age[1] * P.age[2] * P.age[3] / (a*a*a*a) ,4.0f/4.0f);

      a = P.income[1] + P.income[2] + P.income[3] + P.income[4] + 0.0001f;
      a /= 4;
      b += pow(P.income[1] * P.income[2] * P.income[3] * P.income[4] / (a*a*a*a) ,4.0f/4.0f);

      a = P.education[1] + P.education[2] + P.education[3] + 0.0001f;
      a /= 3;
      b += pow(P.education[1] * P.education[2] * P.education[3] / (a*a*a) ,4.0f/3.0f);

      a = P.migration[0] + P.migration[1] + P.migration[2] + 0.0001f;
      a /= 3;
      b += pow(P.migration[0] * P.migration[1] * P.migration[2] / (a*a*a) ,4.0f/3.0f);

      P.heter = 10.0f + b * 18.0f;
    }
  }

  private void writePath()
  {
    println("writing path.txt");
    PrintWriter writer = createWriter("data/path.txt");
    int n = polls.size();
    Poll poll = null;
    Point point = null;
    Label label = null;
    for(int i = 0; i < n ; i++)
    {
      poll = (Poll)polls.get(i);
      for(int j=0; j < 2 ; ++j)
      {
        int m = poll.path[j].points.size();
        for(int k=0; k < m ; ++k)
        {
          point = (Point)poll.path[j].points.get(k);
          label = (Label)poll.path[j].labels.get(k);
          // Fortlaufende Nummer im Pfad | Poll-ID | Path-ID ()
          writer.println(k + "\t" + poll.id + "\t" + j + "\t" + label.id + "\t" + point.id);
        }
      }
    }
    writer.flush();
    writer.close();
  }

  private void filter(int gender, int minage, int maxage, int minmigration, int maxmigration, int mineducation, int maxeducation, float minincome, float maxincome)
  {
    int n;
    // Z\u00e4hler auf Null setzten
    // Punkte
    n = points.size();
    for(int i=0; i < n ; ++i)
    {
      Point point = (Point) points.get(i);
      point.count = 0;
    }
    // Statistik neu berechnen - Reset
    statisticsReset();

    // Wegelemente
    n = pairs.size();
    for(int i = 0; i < n ; ++i)
    {
      Pair pair = (Pair)pairs.get(i);
      pair.count = 0;
    }

    // Polls durchgehen und durchz\u00e4hlen
    n = polls.size();
    for(int i = 0; i < n ; ++i)
    {
      Poll poll = (Poll) polls.get(i);

      // Filterbedingung:
      if ( ( (poll.gender == gender) || (gender == 0) ) && (poll.age > minage ) && (poll.age <= maxage) && ( poll.migration >= minmigration) && (poll.migration <= maxmigration) && ( poll.education >= mineducation) && ( poll.education <= maxeducation ) && (poll.income > minincome ) && ( poll.income <= maxincome) )
      {
        // println(poll.gender + " - " + poll.age + " - " + poll.migration + " - " + poll.education + " - " + poll.income );
        poll.speed = 1.2f - 0.01f * poll.age;
        for(int j=0; j < 2 ; ++j)
        {
          int m;
          // Punkte
          m = poll.path[j].points.size();
          for(int k=0; k < m ; ++k)
          {
            Point point = (Point) poll.path[j].points.get(k);
            Label label = (Label) poll.path[j].labels.get(k);
            if (label.id > 0)
            {
              ++point.count;
            }
            // Statistik neu berechnen
            statisticsOnPoint(poll, point, label);
          }
          // Wegelemente
          m = poll.path[j].pairs.size();
          for(int k=0; k < m ; ++k)
          {
            Pair pair = (Pair) poll.path[j].pairs.get(k);
            ++pair.count;
          }
        }
      }
      else // Filterbedingung
      {
        poll.speed = 0.0f;
      }
    }
  }

  public void mergePoints()
  // Set Viewer into Merge-Points-Mode
  {
    if (selected != null)
    {
      if (mode == 2)
      {
        if ((temp != null) && (temp != selected))
        {
          replacePoint(selected,temp);
        }
        selected = null;
        temp = null;
        mode = 0;
      }
      else
      {
        temp = selected;
        selected = null;
        mode = 2;
      }
    }
    else
    {
      temp = null;
      mode = 0;
    }
  }

  public void replacePoint(Point a, Point b)
  // Replace every Point a with Point b in all Polls and Pairs
  // Point a should be unused afterwards and could be deleted.
  {
    int n;
    // Loop all Polls
    n = polls.size();
    for(int i = 0; i < n ; ++i)
    {
      Poll poll = (Poll) polls.get(i);
      for(int j=0; j < 2 ; ++j)
      {
        int m = poll.path[j].points.size();
        for(int k=0; k < m ; ++k)
        {
          Point point = (Point) poll.path[j].points.get(k);
          if (point == a)
          {
            poll.path[j].points.set(k,b);
            println("Poll " + poll.id + " : replacing Point " + a.id + " with " + b.id);
            // Punkt - Label verkn\u00fcpfung f\u00fcr Punkt b einf\u00fcgen
            Label label = (Label) poll.path[j].labels.get(k);
            addLabelToPoint(label,b);
          }
        }
      }
    }
    // Loop all Pairs
    n = pairs.size();
    for(int i = 0; i < n ; ++i)
    {
      Pair pair = (Pair)pairs.get(i);
      if (pair.a == a)
      {
        pair.a = b;
        println("Pair " + i + " : replacing Point " + a.id + " with " + b.id);
      }
      if (pair.b == a)
      {
        pair.b = b;
        println("Pair " + i + " : replacing Point " + a.id + " with " + b.id);
      }
    }
    // Finally remove point a
    n = points.indexOf(a);
    points.remove(n);
  }

  public Label findOrAddLabel(String text)
  {
    int n;
    // Search for existing Label
    n = labels.size();
    Label L = null;
    for(int i = 0; i < n ; i++)
    {
      L = (Label)labels.get(i);
      if (L.text == text) return L;
    }
    // Not found -> Add new
    L = new Label();
    L.id  = (short) n;
    L.text = text;
    labels.add(L);
    return L;
  }

  public void renamePoint(String text)
  {
    if (selected != null)
    {
      renamePoint(selected, text);
    }
  }

  private void renamePoint(Point point, String text)
  {
    Label label = (Label)labels.get(0);
    Integer lcount = 0;
    int n;
    n = point.labels.indexOf(label);
    if (n > -1)
    {
      lcount = (Integer)point.lcount.get(n);
    }
    point.labels.clear();
    point.lcount.clear();
    point.labels.add(label);
    point.lcount.add(lcount);

    label = findOrAddLabel(text);

    // Loop all Polls
    n = polls.size();
    for(int i = 0; i < n ; ++i)
    {
      Poll poll = (Poll) polls.get(i);
      for(int j=0; j < 2 ; ++j)
      {
        int m = poll.path[j].points.size();
        for(int k=0; k < m ; ++k)
        {
          Point P = (Point) poll.path[j].points.get(k);
          if (P == point)
          {
            Label L = (Label) poll.path[j].labels.get(k);
            if ((L.id != 0) && (L.id != label.id))
            {
              --L.count;
              ++label.count;
              poll.path[j].labels.set(k,label);
              addLabelToPoint(label,point);
              println("Poll " + poll.id + " : replacing Label " + L.id + " with " + label.id);
            }
          }
        }
      }
    }

  }

  private void splitPoint()
  {
    Point point = selected;
    // Point P = null;
    int n;
    int firstNewPointID = points.size();

    // Create new Points
    n = point.labels.size();
    for(int i = 0; i < n ; ++i)
    {
      Point P = new Point();
      P.id    = points.size();
      P.x     = point.x + 3*i;
      P.y     = point.y;
      P.labels  = new ArrayList();
      P.lcount  = new ArrayList();
      Label L = (Label)point.labels.get(i);
      P.labels.add(L);
      Integer lcount = (Integer)point.lcount.get(i);
      P.lcount.add(lcount);
      P.count = (short)PApplet.parseInt(lcount);
      points.add(P);
    }

    // Loop all Polls
    n = polls.size();
    for(int i = 0; i < n ; ++i)
    {
      Poll poll = (Poll) polls.get(i);
      for(int j=0; j < 2 ; ++j)
      {
        int m = poll.path[j].points.size();
        for(int k=0; k < m ; ++k)
        {
          Point P = (Point) poll.path[j].points.get(k);
          if (P == point)
          {
            Label L = (Label) poll.path[j].labels.get(k);
            int id = firstNewPointID + point.labels.indexOf(L);
            poll.path[j].points.set(k,(Point)points.get(id));
            // Update Pairs
            if (k > 0)
            {
              Pair pair = findOrAddPair((Point)poll.path[j].points.get(k-1),(Point)poll.path[j].points.get(k));
              poll.path[j].pairs.set(k-1,pair);
            }
            if (k < m-1)
            {
              Pair pair = findOrAddPair((Point)poll.path[j].points.get(k),(Point)poll.path[j].points.get(k+1));
              poll.path[j].pairs.set(k,pair);
            }
          }
        }
      }
    }
    
    // Delete old Point from List
    n = points.indexOf(selected);
    points.remove(n);

    selected = null;
  }
  
  // Split Path a insterting b
  public void splitPair(Pair a, Point b)
  {
    Pair a1 = findOrAddPair(a.a,b);
    Pair a2 = findOrAddPair(a.b,b);
    a1.count += a.count;
    a2.count += a.count;
    Label label = (Label)labels.get(0);
    int n = polls.size();
    for(int i = 0; i < n ; ++i)
    {
      Poll poll = (Poll) polls.get(i);
      for(int j=0; j < 2 ; ++j)
      {
        int m = poll.path[j].pairs.size();
        for(int k=0; k < m ; ++k)
        {
          Pair pair = (Pair) poll.path[j].pairs.get(k);
          if (pair == a)
          {
            poll.path[j].points.add(k,b);
            poll.path[j].labels.add(k,label);
            println("Poll " + poll.id + " : inserting Point " + b.id + " at " + k);
            poll.path[j].pairs.set(k,a1);
            poll.path[j].pairs.add(k,a2);
          }
        }
      }
    }
    n = pairs.size();
    for(int i = 0; i < n ; ++i)
    {
      Pair pair = (Pair) pairs.get(i);
      if (pair == a)
      {
        println("Pair " + i + " : inserting Point " + b.id);
        pairs.set(i,a1);
        pairs.add(i,a2);
      }
    }
  }

  public void markPoint(int mark)
  {
    if (selected != null)
    {
      selected.mark = (short) mark;
    }
  }
  
} // End Class Viewer




  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--hide-stop", "imap_interface_v3" });
  }
}
